VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmController 
   Caption         =   "Controller"
   ClientHeight    =   3720
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3615
   Icon            =   "frmController.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3720
   ScaleWidth      =   3615
   StartUpPosition =   3  'Windows Default
   Begin VB.OptionButton OffLine 
      Caption         =   "Waiting for Special Move"
      Height          =   375
      Left            =   600
      TabIndex        =   10
      Top             =   2760
      Width           =   2295
   End
   Begin MSCommLib.MSComm RobotLink 
      Left            =   3960
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.CommandButton btnConnect 
      Caption         =   "Connect"
      Height          =   495
      Left            =   1118
      TabIndex        =   2
      Top             =   720
      Width           =   1335
   End
   Begin VB.ComboBox CommPort 
      Height          =   315
      Left            =   2400
      TabIndex        =   1
      Top             =   120
      Width           =   1095
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      Caption         =   "Tilt"
      Height          =   255
      Left            =   2400
      TabIndex        =   9
      Top             =   1680
      Width           =   855
   End
   Begin VB.Label TiltBox 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   2400
      TabIndex        =   8
      Top             =   2040
      Width           =   855
   End
   Begin VB.Label PanBox 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   1320
      TabIndex        =   7
      Top             =   2040
      Width           =   855
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Pan"
      Height          =   255
      Left            =   1320
      TabIndex        =   6
      Top             =   1680
      Width           =   855
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Motion"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   1680
      Width           =   855
   End
   Begin VB.Label MotionBox 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Top             =   2040
      Width           =   855
   End
   Begin VB.Label lblConnected 
      Alignment       =   2  'Center
      Caption         =   "Connected to Robot"
      Height          =   255
      Left            =   480
      TabIndex        =   3
      Top             =   1320
      Visible         =   0   'False
      Width           =   2775
   End
   Begin VB.Label lblConnect 
      Caption         =   "Set Comm Port and Connect"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2415
   End
End
Attribute VB_Name = "frmController"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Variables for the DirectX interface to the Joystick
Dim dx As New DirectX8
Dim di As DirectInput8
Dim diDev As DirectInputDevice8
Dim diDevEnum As DirectInputEnumDevices8
Dim joyCaps As DIDEVCAPS
Dim JoyStick As DIJOYSTATE
Dim OnLine As Boolean
Dim DiProp_Dead As DIPROPLONG
Dim DiPRop_Range As DIPROPRANGE
Dim DiProp_Saturation As DIPROPLONG

'General Purpose Variables
Dim CommandSent

'Variables to control the robot
Dim Motion As String
Dim Lights As String
Dim Tilt As String
Dim Pan As String
Dim Gripper As String
Dim SpecialMove As String

'Variables to control the rate of transmission to the robot
Dim CommandString As String
Dim OldCommand As String
Public Sub PauseIt(Pause As Double)
Dim StartTime As Double
StartTime = Now()
Do Until (Now() - StartTime) > (Pause / (3600# * 24#))
    DoEvents
Loop
End Sub

Public Sub SendCommand()
    RobotLink.Output = "ZZ" & CommandString
End Sub
Public Sub JoyStickLoop()
While OnLine = True
    'Set the command characters to blanks
    Motion = " "
    Pan = " "
    Tilt = " "
    Lights = " "
    Gripper = " "
    SpecialMove = " "
    diDev.GetDeviceStateJoystick JoyStick
    'Get joystick positions for movement
    Select Case JoyStick.z
        Case 0 To 1500
            Motion = "F"
        Case 1501 To 3500
            Motion = "f"
        Case 3501 To 6500
            Motion = "S"
        Case 6501 To 8500
            Motion = "b"
        Case 8501 To 10000
            Motion = "B"
    End Select
    Select Case JoyStick.rz
        Case 0 To 1500
            Motion = "L"
        Case 8501 To 10000
            Motion = "R"
    End Select
    MotionBox.Caption = Motion
    Select Case JoyStick.y
        Case 0 To 1500
            Tilt = "U"
        Case 1501 To 3500
            Tilt = "u"
        Case 3501 To 6500
            Tilt = "C"
        Case 6501 To 8500
            Tilt = "d:"
        Case 8501 To 10000
            Tilt = "D"
    End Select
    TiltBox.Caption = Tilt
    Select Case JoyStick.x
        Case 0 To 1500
            Pan = "L"
        Case 1501 To 4000
            Pan = "l"
        Case 4001 To 6000
            Pan = "C"
        Case 6001 To 8500
            Pan = "r"
        Case 8501 To 10000
            Pan = "R"
    End Select
    PanBox.Caption = Pan
    'Get the button status - note the button array is 1 less
    'than the numbers on the controller.
    If JoyStick.Buttons(6) Then
        Lights = "L"
    End If
    If JoyStick.Buttons(7) Then
        Lights = "R"
    End If
        If JoyStick.Buttons(4) Then
        Gripper = "O"
    End If
    If JoyStick.Buttons(5) Then
        Gripper = "C"
    End If
    If JoyStick.Buttons(1) Then
        SpecialMove = "P"
    End If
    If JoyStick.Buttons(3) Then
        SpecialMove = "Q"
    End If
    CommandString = Motion & Pan & Tilt & Lights & Gripper & SpecialMove
    'Send changes immediately and repeat about every 1 sec. in case the STAMP
    'was busy when the last was sent.
    If CommandString <> OldCommand Then
        SendCommand
        DoEvents
        CommandSent = 0
    Else
        CommandSent = CommandSent + 1
        'This comparison may need to be changed depending on the speed of the
        'computer. With my twin 2.8Ghz Xeon this is about 1 sec.
        If CommandSent > 70000 Then
            SendCommand
            DoEvents
            CommandSent = 0
        End If
    End If
    OldCommand = CommandString
    DoEvents
    
    'Stop transmitting if one of the stored moves is requested, as the
    'Stamp will be busy for a while and I don't want to fill the output buffer.
    If SpecialMove <> " " Then
        OffLine.Value = True
        PauseIt (10)
        OffLine.Value = False
    End If
    
Wend
End Sub

Private Sub btnConnect_Click()
'Connect to the Robot via the BlueTooth adaptor.

RobotLink.CommPort = CommPort.Text
RobotLink.PortOpen = True

'Initialize the Joystick Object
Set di = dx.DirectInputCreate
Set diDevEnum = di.GetDIDevices(DI8DEVCLASS_GAMECTRL, DIEDFL_ATTACHEDONLY)
Set diDev = di.CreateDevice(diDevEnum.GetItem(1).GetGuidInstance)
diDev.SetCommonDataFormat DIFORMAT_JOYSTICK
diDev.GetCapabilities joyCaps
 
With DiProp_Dead
.lData = 1000
.lHow = DIPH_BYOFFSET
 
.lObj = DIJOFS_X
diDev.SetProperty "DIPROP_DEADZONE", DiProp_Dead
 
.lObj = DIJOFS_Y
diDev.SetProperty "DIPROP_DEADZONE", DiProp_Dead

.lObj = DIJOFS_Y
diDev.SetProperty "DIPROP_DEADZONE", DiProp_Dead

.lObj = DIJOFS_RZ
diDev.SetProperty "DIPROP_DEADZONE", DiProp_Dead
End With
 
With DiProp_Saturation
.lData = 9500
.lHow = DIPH_BYOFFSET
 
.lObj = DIJOFS_X
diDev.SetProperty "DIPROP_SATURATION", DiProp_Saturation
 
.lObj = DIJOFS_Y
diDev.SetProperty "DIPROP_SATURATION", DiProp_Saturation
End With
 
With DiPRop_Range
.lHow = DIPH_DEVICE
.lMin = 0
.lMax = 10000
End With
 
diDev.SetProperty "DIPROP_RANGE", DiPRop_Range
diDev.Acquire

lblConnected.Visible = True
btnConnect.Enabled = False
OnLine = True

JoyStickLoop
End Sub

Private Sub Form_Load()
CommPort.AddItem "1"
CommPort.AddItem "2"
CommPort.AddItem "3"
CommPort.AddItem "4"
CommPort.AddItem "5"
CommPort.AddItem "6"
CommPort.AddItem "7"
CommPort.AddItem "8"
CommPort.AddItem "9"
CommPort.AddItem "10"
CommPort.AddItem "11"
CommPort.AddItem "12"
CommPort.AddItem "13"
CommPort.AddItem "14"
CommPort.AddItem "15"
CommPort.AddItem "16"
CommPort.AddItem "17"
CommPort.AddItem "18"
CommPort.AddItem "19"

OffLine.Value = False

End Sub
Private Sub Form_Unload(Cancel As Integer)
OnLine = False
'Disconnect the JoyStick link
diDev.Unacquire
Set diDev = Nothing
Set diDevEnum = Nothing
Set di = Nothing
End Sub

